Capabilities - Create Or Update
Create or update a Capability resource that extends a Target resource.
PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{parentProviderNamespace}/{parentResourceType}/{parentResourceName}/providers/Microsoft.Chaos/targets/{targetName}/capabilities/{capabilityName}?api-version=2025-01-01
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
capability
|
path | True |
string pattern: ^[a-zA-Z0-9\-\.]+-\d\.\d$ |
String that represents a Capability resource name. |
|
parent
|
path | True |
string maxLength: 63pattern: ^[a-zA-Z0-9][a-zA-Z0-9-_.]{2,62}$ |
The parent resource provider namespace. |
|
parent
|
path | True |
string maxLength: 63pattern: ^[a-zA-Z0-9][a-zA-Z0-9-_.]{2,62}$ |
The parent resource name. |
|
parent
|
path | True |
string maxLength: 63pattern: ^[a-zA-Z0-9][a-zA-Z0-9-_.]{2,62}$ |
The parent resource type. |
|
resource
|
path | True |
string minLength: 1maxLength: 90 |
The name of the resource group. The name is case insensitive. |
|
subscription
|
path | True |
string (uuid) |
The ID of the target subscription. The value must be an UUID. |
|
target
|
path | True |
string pattern: ^[a-zA-Z0-9_\-\.]+$ |
String that represents a Target resource name. |
|
api-version
|
query | True |
string minLength: 1 |
The API version to use for this operation. |
Responses
| Name | Type | Description |
|---|---|---|
| 200 OK |
Resource 'Capability' update operation succeeded |
|
| 201 Created |
Resource 'Capability' create operation succeeded |
|
| Other Status Codes |
An unexpected error response. |
Security
azure_auth
Azure Active Directory OAuth2 Flow.
Type:
oauth2
Flow:
implicit
Authorization URL:
https://login.microsoftonline.com/common/oauth2/authorize
Scopes
| Name | Description |
|---|---|
| user_impersonation | impersonate your user account |
Examples
Create/update a Capability that extends a virtual machine Target resource.
Sample request
PUT https://management.azure.com/subscriptions/6b052e15-03d3-4f17-b2e1-be7f07588291/resourceGroups/exampleRG/providers/Microsoft.Compute/virtualMachines/exampleVM/providers/Microsoft.Chaos/targets/Microsoft-VirtualMachine/capabilities/Shutdown-1.0?api-version=2025-01-01
{
"properties": {}
}
Sample response
{
"name": "Shutdown-1.0",
"type": "Microsoft.Chaos/targets/capabilities",
"id": "/subscriptions/6b052e15-03d3-4f17-b2e1-be7f07588291/resourceGroups/exampleRG/providers/Microsoft.Compute/virtualMachines/exampleVM/providers/Microsoft.Chaos/targets/Microsoft-VirtualMachine/capabilities/Shutdown-1.0",
"properties": {
"description": "Shutdown an Azure Virtual Machine for a defined period of time.",
"parametersSchema": "https://schema.centralus.chaos-prod.azure.com/targets/Microsoft-VirtualMachine/capabilities/Shutdown-1.0.json",
"publisher": "Microsoft",
"targetType": "VirtualMachine",
"urn": "urn:csci:microsoft:virtualMachine:shutdown/1.0"
},
"systemData": {
"createdAt": "2020-05-14T05:08:38.4662189Z",
"lastModifiedAt": "2020-05-14T05:08:38.4662189Z"
}
}
{
"name": "Shutdown-1.0",
"type": "Microsoft.Chaos/targets/capabilities",
"id": "/subscriptions/6b052e15-03d3-4f17-b2e1-be7f07588291/resourceGroups/exampleRG/providers/Microsoft.Compute/virtualMachines/exampleVM/providers/Microsoft.Chaos/targets/Microsoft-VirtualMachine/capabilities/Shutdown-1.0",
"properties": {
"description": "Shutdown an Azure Virtual Machine for a defined period of time.",
"parametersSchema": "https://schema.centralus.chaos-prod.azure.com/targets/Microsoft-VirtualMachine/capabilities/Shutdown-1.0.json",
"publisher": "Microsoft",
"targetType": "VirtualMachine",
"urn": "urn:csci:microsoft:virtualMachine:shutdown/1.0"
},
"systemData": {
"createdAt": "2020-05-14T05:08:38.4662189Z",
"lastModifiedAt": "2020-05-14T05:08:38.4662189Z"
}
}
Definitions
| Name | Description |
|---|---|
| Capability |
Model that represents a Capability resource. |
|
created |
The type of identity that created the resource. |
|
Error |
The resource management error additional info. |
|
Error |
The error detail. |
|
Error |
Error response |
|
system |
Metadata pertaining to creation and last modification of the resource. |
Capability
Model that represents a Capability resource.
| Name | Type | Description |
|---|---|---|
| id |
string (arm-id) |
Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}" |
| name |
string |
The name of the resource |
| properties.description |
string |
Localized string of the description. |
| properties.parametersSchema |
string maxLength: 2048 |
URL to retrieve JSON schema of the Capability parameters. |
| properties.publisher |
string |
String of the Publisher that this Capability extends. |
| properties.targetType |
string |
String of the Target Type that this Capability extends. |
| properties.urn |
string maxLength: 2048 |
String of the URN for this Capability Type. |
| systemData |
Azure Resource Manager metadata containing createdBy and modifiedBy information. |
|
| type |
string |
The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts" |
createdByType
The type of identity that created the resource.
| Value | Description |
|---|---|
| User | |
| Application | |
| ManagedIdentity | |
| Key |
ErrorAdditionalInfo
The resource management error additional info.
| Name | Type | Description |
|---|---|---|
| info |
object |
The additional info. |
| type |
string |
The additional info type. |
ErrorDetail
The error detail.
| Name | Type | Description |
|---|---|---|
| additionalInfo |
The error additional info. |
|
| code |
string |
The error code. |
| details |
The error details. |
|
| message |
string |
The error message. |
| target |
string |
The error target. |
ErrorResponse
Error response
| Name | Type | Description |
|---|---|---|
| error |
The error object. |
systemData
Metadata pertaining to creation and last modification of the resource.
| Name | Type | Description |
|---|---|---|
| createdAt |
string (date-time) |
The timestamp of resource creation (UTC). |
| createdBy |
string |
The identity that created the resource. |
| createdByType |
The type of identity that created the resource. |
|
| lastModifiedAt |
string (date-time) |
The timestamp of resource last modification (UTC) |
| lastModifiedBy |
string |
The identity that last modified the resource. |
| lastModifiedByType |
The type of identity that last modified the resource. |